<?php
/*
Plugin Name: Like Twitter Tags
Plugin URI:  
Description: Creates search links for your Wordpress blog from #tagname  anywhere within your blog posts, comments and RSS feeds
Correct work with cyrillic symbols
Version: 0.2
Author: Kvisaz
Author URI: http://kvisaz.ru
*/

//1
add_filter ('the_content', 'LikeTwitterTags',10002); 
add_filter ('the_content_feed', 'LikeTwitterTags',10002);
add_filter('comment_text','LikeTwitterTags',10002); 
add_filter('comment_text_rss','LikeTwitterTags',10002);

//2
function LikeTwitterTags($content){
	$content = replace_content($content);
return $content;
}

$YourBlogUrl = rtrim(get_option('siteurl'),"/");
$YourBlogUrl = $YourBlogUrl."?s=";

	function replace_content( $content = '' ) {
		global $YourBlogUrl;
		$content = iconv('UTF-8', 'cp1251',$content);
		$matchhash = "/(^|\s|>)#([a-zA-Zа-яА-Я0-9]+)/";
		$matchhash = iconv('UTF-8', 'cp1251',$matchhash);
		$content = preg_replace_callback($matchhash, 'replace_twitter_tag', $content );
		$content = iconv('cp1251','UTF-8', $content);		
		return $content;
	}
	
	function replace_twitter_tag ($data){
		global $YourBlogUrl;
		$sym = substr($data[0],0,1);
		$tag = substr($data[0],1);; // tag
		$searchtext = substr($tag,1); // kill hash
		
		$url = $YourBlogUrl;
		
		$atr = "title=\"Search my site \"";
		
		$query = $sym."<a href=\"".$url.$searchtext."\" ".$atr." >".$tag."</a>";			
		
		return $query;
	}

?>